//###########################################################################
//# ftpbnc 0.1 by comrade
//# comrade2k@hotmail.com
//# http://comrade64.cjb.net/
//###########################################################################
//###########################################################################
#include <stdio.h>
#include <stdlib.h>
#include <stdarg.h>
#include <string.h>
#include <sys/socket.h>
#include <sys/time.h>
#include <sys/types.h>
#include <netinet/in.h>
#include <netdb.h>
#include <signal.h>
#include <unistd.h>
#include <fcntl.h>
#include <errno.h>
//###########################################################################
#define DATA_SIZE 8192
#define MAX_SOCKETS 128
//###########################################################################
int csockets[MAX_SOCKETS], rsockets[MAX_SOCKETS], sockets=0;
int lsock, csock, rsock;
unsigned char *welcome = "220 [ftpbnc 0.1 by comrade] ready\x0D\x0A";
//###########################################################################
int main(int, char**);
void log(const char*, ...);
void remove_conn(unsigned int);
void sigterm(int);
//###########################################################################
//###########################################################################
//###########################################################################
//###########################################################################
int main(int argc, char **argv){
	FILE* hFile; unsigned char pid[16]; unsigned int optval; char *lhost, *rhost, *lport, *rport;
	struct sockaddr_in lsin, sin; struct hostent *hp;
	char *local, *remote; unsigned int localb, remoteb;
	int i;
	fd_set in; struct timeval tv;

	log("  ftpbnc 0.1 by comrade\n  comrade2k@hotmail.com\n  http://comrade64.cjb.net/");
	if (argc != 3){
		log("Usage: ftpbnc listenhost listenport");
		return 0;
	}
	//signal(SIGHUP, SIG_IGN);
	signal(SIGTERM, sigterm);
	if (fork()) return 0;	// parent
	lhost = argv[1];
	lport = argv[2];
	*(lport-1)=0;

	hFile = fopen("ftpbnc.pid", "wb");
	fwrite(&pid, sprintf(pid, "%lu\n", getpid()), 1, hFile);
	fclose(hFile);
	log("\nSuccessfully loaded into background (PID %lu)...", getpid());
	if ((lsock = socket(AF_INET, SOCK_STREAM, 0)) == -1){ log("Failed to create socket!\n"); return 0; }
	optval = 1;
	if (setsockopt(lsock, SOL_SOCKET, SO_REUSEADDR, &optval, sizeof(optval))){ log("Failed to set socket options!\n"); return 0; }
	lsin.sin_family = AF_INET; lsin.sin_port = htons(atoi(lport));
	if ((lsin.sin_addr.s_addr = inet_addr(lhost)) == INADDR_NONE){
		if (!(hp = gethostbyname(lhost))){ log("Invalid listen hostname!"); return 0; }
		memcpy(&lsin.sin_addr, hp->h_addr, hp->h_length);
	}
	if (bind(lsock, (struct sockaddr*)&lsin, sizeof(lsin))){ log("Failed to bind socket!\n"); return 0; }
	if (listen(lsock, 5)){ log("Failed to listen on socket!\n"); return 0; }
	remote = malloc(DATA_SIZE);
	local = malloc(DATA_SIZE);
	while(1){
		// accept new connections
		FD_ZERO(&in);
		FD_SET(lsock, &in);
		tv.tv_sec = 0; tv.tv_usec = 250;
		if (select(lsock+1, &in, 0, 0, &tv)){
			if (FD_ISSET(lsock, &in)){
				if ((csock = accept(lsock, 0, 0)) > 0){
					fcntl(csock, F_SETFL, O_NONBLOCK);
					csockets[sockets] = csock;
					rsockets[sockets++] = 0;
					send(csock, welcome, strlen(welcome), 0);
				}
			}
		}
		// bounce data
		for(i = 0; i < sockets; i++){
			memset( local, 0, DATA_SIZE);
			memset(remote, 0, DATA_SIZE);
			if      ((csockets[i]) && !( localb = recv(csockets[i],  local, DATA_SIZE, 0))) remove_conn(i);
			else if ((rsockets[i]) && !(remoteb = recv(rsockets[i], remote, DATA_SIZE, 0))) remove_conn(i);
			else {
				if (csockets[i] && !rsockets[i] && localb && (localb <= DATA_SIZE)){ // not connected yet
					local[localb-2] = 0;
					rhost = &local[5];
					if (!(rport = strchr(rhost, ':'))) rport = strchr(rhost, ' ');
					sin.sin_family = AF_INET;
					if (rport) {
						*rport++=0;
						sin.sin_port = htons(atoi(rport));
					}
					else sin.sin_port = htons(21);
					//log("Connecting to %s:%u...", rhost, ntohs(sin.sin_port));

					rsock = socket(AF_INET, SOCK_STREAM, 0);
					lsin.sin_port = 0;
					bind(rsock, (struct sockaddr*)&lsin, sizeof(lsin));
					if ((sin.sin_addr.s_addr = inet_addr(rhost)) == INADDR_NONE){
						if (!(hp = gethostbyname(rhost))) break;
						memcpy(&sin.sin_addr, hp->h_addr, hp->h_length);
					}
					if (!connect(rsock, (struct sockaddr*)&sin, sizeof(sin))){
						//log("Connected!");
						fcntl(rsock, F_SETFL, O_NONBLOCK);
						rsockets[i] = rsock;
					} else {
						remove_conn(i);
					}
					localb = 0; remoteb = 0;
				}
				if (( localb <= DATA_SIZE) &&  localb && rsockets[i]) send(rsockets[i],  local,  localb, 0);
				if ((remoteb <= DATA_SIZE) && remoteb && csockets[i]) send(csockets[i], remote, remoteb, 0);
			}
		}
	}
	free(local);
	free(remote);
	close(rsock); close(csock); close(lsock);
	return 0;
}
//###########################################################################
void log(const char *format, ...){
	va_list args;
	va_start(args, format);
	vprintf(format, args);
	va_end(args);
	puts("");
	return;
}
//###########################################################################
void remove_conn(unsigned int index){
	//log("Removing connection %u", index);
	close(csockets[index]); close(rsockets[index]);
	memcpy(&csockets[index], &csockets[index+1], (MAX_SOCKETS-index-1)*sizeof(int));
	memcpy(&rsockets[index], &rsockets[index+1], (MAX_SOCKETS-index-1)*sizeof(int));
	sockets--;
}
//###########################################################################
void sigterm(int sig){
	int i=0;
	for(i; i < sockets; i++){
		close(csockets[i]); close(rsockets[i]);
	}
	close(rsock); close(csock); close(lsock);
	exit(0);
	return;
}
//###########################################################################
//###########################################################################
